%define rtsp_server_user rtspd

Summary: targetcli based storage ansible role
Name: rtsp-server
Version: 0.5.0snap.20200415
Release: 1
URL: https://github.com/revmischa/%{name}
Source0: %{name}-%{version}.tar.xz
License: ABRMS
BuildArch: noarch

Requires: perl
Requires: perl-ExtUtils-MakeMaker
Requires: perl-Moose
Requires: perl-URI
Requires: perl-MooseX-Getopt
Requires: perl-AnyEvent
Requires: perl-Socket6
Requires: perl-Test-Moose

BuildRequires: perl
BuildRequires: perl-ExtUtils-MakeMaker
BuildRequires: perl-Moose
BuildRequires: perl-URI
BuildRequires: perl-MooseX-Getopt
BuildRequires: perl-AnyEvent
BuildRequires: perl-Socket6
BuildRequires: perl-Test-Moose

%description
This module is designed to accept a number of sources to connect and
transmit audio and video streams. Clients can connect and send RTSP
commands to receive RTP data.

This was designed to make rebroadcasting audio and video data over a
network simple.

Note: The server is configured to be run as user %{rtsp_server_user}
and therefor will use alternate RSTP port (8554).

%prep
%setup -q
%{__perl} Makefile.PL

%build
make

%check
make test

%install
rm -rf %{buildroot}
make INSTALLDIRS=vendor DESTDIR=%{buildroot} create_packlist=0 install
rm %{buildroot}/%{_libdir}/perl5/perllocal.pod \
   %{buildroot}/%{_libdir}/perl5/vendor_perl/auto/RTSP/Server/.packlist

mkdir -p %{buildroot}/etc/systemd/system
cat > %{buildroot}%{_sysconfdir}/systemd/system/%{name}.service << EOF
[Unit]
Description=RTSP Server

[Service]
Type=simple
User=%{rtsp_server_user}
ExecStart=%{perl_vendorlib}/RTSP/%{name}.pl -c 8554
Restart=on-failure
EOF

%clean
rm -rf %{buildroot}

%pre
# add our user if it does not exist
getent passwd %{rtsp_server_user} >/dev/null || {
    useradd --system --create-home \
        --home-dir /home/%{rtsp_server_user} \
        --comment "Remote Place Assigner Daemon" \
        %{rtsp_server_user}
}
systemctl daemon-reload

%postun
if [[ "$1" == 0 ]]
then # uninstall
    # remove our user
    userdel --remove "%{rtsp_server_user}" >/dev/null 2>&1 || \
        echo "warning: failed to remove user %{rtsp_server_user}" >&2
    systemctl daemon-reload
fi

%files
%defattr(-,root,root)
%{_mandir}/man3/RTSP::Server.3pm.*
%{perl_vendorlib}/RTSP
%attr(0755,-,-) %{perl_vendorlib}/RTSP/%{name}.pl
%{_sysconfdir}/systemd/system/%{name}.service
%doc README.md
